﻿using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace EncodeDecodeZipInDb
{
    public partial class frmEncDecZip : Form
    {
        public frmEncDecZip()
        {
            InitializeComponent();
        }

        private void Btn_AddFileToDB_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog1 = new OpenFileDialog();
            openFileDialog1.Filter = "ZIP Files (.zip)|*.zip";
            openFileDialog1.FilterIndex = 1;
            openFileDialog1.ShowDialog();

            if (openFileDialog1.FileName.Trim() != "")
            {
                Byte[] Byt_ZipFile = null;
                Byt_ZipFile = UDF_ZipToByte(openFileDialog1.FileName.Trim());
                Class_ByteEncryption BytEnc = new Class_ByteEncryption(Byt_ZipFile);// Encrypt Bytes . . . 
                BytEnc.UDF_EncryptBytes();
                Byt_ZipFile = BytEnc.Byt_CryptedBytes;
                UDF_SaveFileToDB(openFileDialog1.SafeFileName.Trim()/*Get Just FileName with Extention*/, Byt_ZipFile);
            }
            
        }

        /// <summary>
        /// File To Byte
        /// </summary>
        /// <param name="filePath"></param>
        /// <returns></returns>
        public static byte[] UDF_ZipToByte(String filePath)
        {
            byte[] buffer;
            FileStream fileStream = new FileStream(filePath, FileMode.Open, FileAccess.Read);
            try
            {
                int length = (int)fileStream.Length;  // get file length
                buffer = new byte[length];            // create buffer
                int count;                            // actual number of bytes read
                int sum = 0;                          // total number of bytes read

                // read until Read method returns 0 (end of the stream has been reached)
                while ((count = fileStream.Read(buffer, sum, length - sum)) > 0)
                    sum += count;  // sum is a buffer offset for next reading
            }
            finally
            {
                fileStream.Close();
            }
            return buffer;
        }

        /// <summary>
        /// Save File From Databse To Zip File
        /// </summary>
        /// <param name="Str_FileName"></param>
        /// <param name="Byt_ZipFile"></param>
        private void UDF_SaveBinaryDateToFile(String Str_FileName, Byte[] Byt_ZipFile)
        {
            FileStream fs = new FileStream(comboBox1.Text.Trim() + Str_FileName, FileMode.Create);
            fs.Write(Byt_ZipFile, 0, Byt_ZipFile.Length);
            fs.Dispose();
        }

        /// <summary>
        /// Save Record To Database
        /// </summary>
        /// <param name="Str_FileName"></param>
        /// <param name="Byt_ZipFile1"></param>
        private void UDF_SaveFileToDB(String Str_FileName , Byte[] Byt_ZipFile1)
        {
            DataSetTableAdapters.tblZipFlesTableAdapter db = new EncodeDecodeZipInDb.DataSetTableAdapters.tblZipFlesTableAdapter();
            db.Insert(Str_FileName.Trim(), Byt_ZipFile1);
            UDF_GetFilesList();
            MessageBox.Show("File Saved In DB . . .");
        }

        /// <summary>
        /// Get File List From Database
        /// </summary>
        private void UDF_GetFilesList()
        {
            DataSetTableAdapters.tblZipFlesTableAdapter db = new EncodeDecodeZipInDb.DataSetTableAdapters.tblZipFlesTableAdapter();
            DataSet.tblZipFlesDataTable dt = new DataSet.tblZipFlesDataTable();
            db.Fill(dt);
            listBox1.Items.Clear();
            foreach (DataRow Row in dt.Rows)
            {
                listBox1.Items.Add("Code = " + Row[0].ToString() + " - Name = " + Row[1]);
            }
        }

        private void frmEncDecZip_Load(object sender, EventArgs e)
        {
            UDF_GetFilesList();
            UDF_GetHardDriveList();
        }

        /// <summary>
        /// Get Hard Disk Drives
        /// </summary>
        private void UDF_GetHardDriveList()
        {
            String[] DriveList = System.IO.Directory.GetLogicalDrives();
            foreach (string str in DriveList)
            {
                comboBox1.Items.Add(str);
                try
                {
                    comboBox1.SelectedIndex = 0;
                }
                catch { }
            }
        }

        private void Btn_SaveToFile_Click(object sender, EventArgs e)
        {
            if (textBox1.Text.Trim() == "")
            {
                MessageBox.Show("Please Enter Zip File Code From List");
            }
            else
            {
                try
                {
                    DataSetTableAdapters.tblZipFlesTableAdapter db = new EncodeDecodeZipInDb.DataSetTableAdapters.tblZipFlesTableAdapter();
                    DataSet.tblZipFlesDataTable dt = new DataSet.tblZipFlesDataTable();
                    db.FillBy(dt, int.Parse(textBox1.Text.Trim()));
                    Class_ByteDecryption DecBytes = new Class_ByteDecryption((Byte[])dt[0][2]);
                    DecBytes.UDF_DencryptBytes();
                    UDF_SaveBinaryDateToFile(dt[0][1].ToString(), DecBytes.Byt_DcryptedBytes);//Saving file to db
                    MessageBox.Show("File Saved . . . ");
                }
                catch { MessageBox.Show("Please Enter Valid Code From List. . ."); }
            }

        }

    }
}
